/************************************************************************
 * Purpose:     A program to time brodcast and return of a message
 *              using MPI_Bcast and MPI_Gather
 *
 * Author:      Steve Alexander CPS615 - Spring 2000
 *
 ************************************************************************/

#include	<stdio.h>
#include	<mpi.h>



#define tag   0

void main ( int argc, char *argv[])
{
  int rank;                /* process rank */
  int j;                   /* counter */
  int length;              /* length of message "buffer" */
  int num_procs;           /* number of processes */
  float buffer[100000];    /* storage for local buffers */
  float buffer_g[100000];  /* storage for all buffers */
  double start;            /* start time */
  double finish;           /* finish time */
  double time;             /* total time */
  MPI_Status status;

  /* start MPI */
  MPI_Init(&argc, &argv);

  MPI_Comm_rank(MPI_COMM_WORLD, &rank);  /* get rank */
  MPI_Comm_size(MPI_COMM_WORLD, &num_procs);  /* get number of processes */

     /*  Send buffer to all other processors using MPI_COMM_WORLD  
         Rank 0 receives a message of same length
         from all other processors */

    if(rank == 0)
    { 
      printf("Length\tTotal Time\n");
      start = MPI_Wtime();   /*get start time*/;
    } 
      /* this loop lets us check the time for varying
         message lengths */
      for (length = 1; length <=  10000; length += 1000)
      {
         
        for (j = 1; j < 100; j++)   /*do it 100 times to make time interval long enough*/
        {
         MPI_Bcast(buffer, length, MPI_FLOAT, 0, MPI_COMM_WORLD);

         MPI_Gather(buffer, length, MPI_FLOAT, buffer_g, length, MPI_FLOAT,
                   0, MPI_COMM_WORLD);
        }
      if(rank == 0)
      { 
       finish = MPI_Wtime(); /*get end time*/
   
       time = finish - start; /*get interval*/

       /*take an average of the length of the message sent
         and the length of the message received, then print
         the result as length*/

       printf("%d\t%f\n", (length + (length * (num_procs - 1)))/2, time/200.0);
      }
     }
  MPI_Finalize();

}

